import * as mc from "@minecraft/server";

const Entity = {
    summonTurret: function (player, x, y, z, mc, dimension, blockType, typeTurret) {
        return new Promise(
            (resolve, reject) => {
                try {
                    const block_head = 'minecraft:dispenser';
                    let block_base = mc.world.getDimension(dimension.id).getBlock({ x: x, y: y, z: z }).permutation.matches(block_head);



                    const block_y_minus_one = mc.world.getDimension(dimension.id).getBlock({ x: x, y: y - 1, z: z }).permutation.matches('minecraft:oak_fence');
                    const block_y_minus_two = mc.world.getDimension(dimension.id).getBlock({ x: x, y: y - 2, z: z }).permutation.matches(blockType);

                    if (block_base && block_y_minus_one && block_y_minus_two) {
                        mc.system.run(() => {
                            mc.world.getDimension(dimension.id).getBlock({ x: x, y: y, z: z }).setPermutation(mc.BlockPermutation.resolve('minecraft:air'));
                            mc.world.getDimension(dimension.id).getBlock({ x: x, y: y - 1, z: z }).setPermutation(mc.BlockPermutation.resolve('minecraft:air'));
                            mc.world.getDimension(dimension.id).getBlock({ x: x, y: y - 2, z: z }).setPermutation(mc.BlockPermutation.resolve('minecraft:air'));

                            const centerX = x + 0.5;
                            const centerZ = z + 0.5;


                            const dx = player.location.x - centerX;
                            const dz = player.location.z - centerZ;
                            const yaw = Math.atan2(dz, dx) * (180 / Math.PI); // Convertir a grados
                            dimension.spawnEntity(typeTurret, { x: centerX, y: y - 2, z: centerZ }).setRotation({ x: 0, y: -yaw });


                            resolve();
                        })

                    } else {
                        reject(new Error("No se puede invocar en esta posición."));
                    }

                } catch (eeerr) {
                    mc.world.sendMessage("eeerr " + eeerr);
                    reject(new Error("eeerr " + eeerr));
                }
            }
        )
    }
}


let isSummoning = false;

mc.world.afterEvents.playerPlaceBlock.subscribe(async (event) => {
    if (event.block.typeId !== 'minecraft:dispenser') return;
    let blockPos = event.block.location;
    const { player } = event;
    if (isSummoning) return;
    isSummoning = true;

    const summons = [
        Entity.summonTurret(player, blockPos?.x, blockPos?.y, blockPos?.z, mc, event.block.dimension, 'minecraft:netherrack', 'wt:netherrack_turret'),
        Entity.summonTurret(player, blockPos?.x, blockPos?.y, blockPos?.z, mc, event.block.dimension, 'minecraft:obsidian', 'wt:obsidian_turret'),
        Entity.summonTurret(player, blockPos?.x, blockPos?.y, blockPos?.z, mc, event.block.dimension, 'minecraft:iron_block', 'wt:iron_turret'),
        Entity.summonTurret(player, blockPos?.x, blockPos?.y, blockPos?.z, mc, event.block.dimension, 'minecraft:gold_block', 'wt:gold_turret'),
        Entity.summonTurret(player, blockPos?.x, blockPos?.y, blockPos?.z, mc, event.block.dimension, 'minecraft:emerald_block', 'wt:emerald_turret'),
        Entity.summonTurret(player, blockPos?.x, blockPos?.y, blockPos?.z, mc, event.block.dimension, 'minecraft:diamond_block', 'wt:diamond_turret'),
        Entity.summonTurret(player, blockPos?.x, blockPos?.y, blockPos?.z, mc, event.block.dimension, 'minecraft:cobblestone', 'wt:stone_turret'),
        Entity.summonTurret(player, blockPos?.x, blockPos?.y, blockPos?.z, mc, event.block.dimension, 'minecraft:dragon_egg', 'wt:dragon_turret')
    ];

    try {
        await Promise.allSettled(summons);
    } catch (eeerr) {
    } finally {
        isSummoning = false;
    }
});